package j51.intel;

/**
 * $Id$
 * $Name$
 *
 * Interface for implements one interrupt source, this interface is
 * used when a SFR coinvolted is written.
 *
 * $Log$
 */
public interface InterruptSource
{
	/**
	 * Return true if the interrupt condition is true
	 */
	public boolean	interruptCondition();

	/**
	 * Return the address of the interrupt service.
	 */
	public int		getInterruptVector();

	/**
	 * Called before to execute the interrupt service.
	 */
	public void		interruptStart();

	/**
	 * Called after the interrupt service is terminated.
	 */
	public void		interruptStop();
}
