package j51.intel;

import java.awt.*;
import javax.swing.*;
import java.util.Vector;

import j51.util.Hex;
import j51.swing.*;

/**
 * $Id$
 * $Name$
 *
 * Standard 8051 uart implementation, no baud rate are used but only
 * the send and receive char from the SBUF register.
 *
 * $Log$
 */

public class JUart extends JPanel implements MCS51Peripheral,
											 SfrWriteListener,
											 SfrReadListener,
											 MCS51Constants
{
	private JTextArea textArea = new JTextArea(1000,80);
	private int sbuf = '?';
	private MCS51 cpu;
	
	public JUart()
	{
		super(new BorderLayout());
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		screen.height /= 3;
		screen.width  /= 3;
		
		setPreferredSize(screen);
		
		JFactory.setTitle(this,"Uart");
		add(new JScrollPane(textArea,
			  JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
			  JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS),BorderLayout.CENTER);
		textArea.setEditable(false);
	}

	public void registerCpu(MCS51 cpu)
	{
		this.cpu = cpu;
		cpu.addSfrWriteListener(MCS51Constants.SBUF,this);
		cpu.addSfrReadListener(MCS51Constants.SBUF,this);
	}

	public int sfrRead(int r)
	{
		switch (r)
		{
			case	SBUF:
					return sbuf;

		}
		
		return 0;
	}

	public void sfrWrite(int r,int v)
	{
		byte b[] = new byte[1];
		switch (r)
		{
			case	SBUF:
					b[0] = (byte)v;
					textArea.append(new String(b));
					textArea.setCaretPosition(textArea.getDocument().getLength());

					// Keep the text area down to a certain character size
					int idealSize = 20 * 1024;
					int maxExcess = 500;
					int excess = textArea.getDocument().getLength() - idealSize;
					if (excess >= maxExcess) 
						textArea.replaceRange("", 0, excess);
					cpu.sfrSet(SCON,SCON_TI);
					break;
		}
	}
}

