package j51.intel;

/**
 * $Id$
 * $Name$
 *
 * Interface for one instruction of the MCS51 processor.
 * 
 * $Log$
 *
 */
public interface MCS51Opcode
{

	/**
	 * Exec one instruction it is important remember that the PC will
	 * be automatically incremented from the MCS51 emulatore BEFORE 
	 * calling this method. That means that the pc parameter is the old
	 * program counter and the function MCS51.pc() if used return the
	 * new one after the execution of the instruction.
	 *
	 * @param cpu - The MCS51 cpu
	 * @param pc - The location of the first byte of the opcode.
	 */
	public void exec(MCS51 cpu,int pc) throws Exception;

	/**
	 * Return the lenght in byte of the instruction.
	 */
	public int getLength();

	/**
	 * Decode one instruction
	 */
	public String decode(MCS51 cpu,int pc);

	/**
	 * Return the number of cycle machine necessary foo execute the
	 * instruction.
	 */
	public int getCycle();

	/**
	 * Get the opcode of the instruction
	 */
	public int getOpcode();

	/**
	 * Return the description of the instruction
	 */
	public String getDescription();

	/**
	 * Clear execution counter
	 */
	public void clearCounter();

	/**
	 * Increment the execution counter
	 */
	public void incCounter();

	/**
	 * Return the cuirrent execution counter
	 */
	public long getCounter();
}
